#include <avr/io.h>         
#include "core.h"

.global SIG_OVERFLOW0
SIG_OVERFLOW0:

; ࠭塞 ﭨ 
;   㦥  ⥪, 㤠  堥 ॣ  

	push	r0
	in		r0,_SFR_IO_ADDR(SREG)
	push	r0
	push	r1
	push	r2
	push	r3
	push	r4
	push	r5
	push	r6
	push	r7
	push	r8
	push	r9
	push	r10
	push	r11
	push	r12
	push	r13
	push	r14
	push	r15
	push	r16
	push	r17
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	push	r23
	push	r24
	push	r25
	push	r26
	push	r27
	push	r28
	push	r29
	push	r30
	push	r31

; ६ 㪠⥫  ⥪   ⠡...

	lds		r28,task_running
	lds		r29,task_running+1

; ...  ࠭塞 㤠 㪠⥫ ⥪

	in		r26,_SFR_IO_ADDR(SPL)
	st		Y,r26
	in		r27,_SFR_IO_ADDR(SPH)
	std		Y+1,r27

;	饬 ᫥ ஢ 
;   㯮   饬 㫥   task_table

task_loop:
	adiw	r28,2
	cpi		r28,lo8(task_table+MAX_TASK_COUNT*2)
	brne	go_on
	ldi		r28,lo8(task_table)
	ldi		r29,hi8(task_table)
 go_on:
	ld		r26,Y		
	ldd		r27,Y+1
	mov		r25,r26
	or		r25,r27
	breq	task_loop

;	諨 ᫥ 
	sts		task_running,r28
	sts		task_running+1,r29

; 堫   
; ⠭ 㪠⥫ ⥪

	out		_SFR_IO_ADDR(SPL),r26
	out		_SFR_IO_ADDR(SPH),r27

; ⠭ SREG   ॣ c  ⥪
	pop		r31
	pop		r30
	pop		r29
	pop		r28
	pop		r27
	pop		r26
	pop		r25
	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r19
	pop		r18
	pop		r17
	pop		r16
	pop		r15
	pop		r14
	pop		r13
	pop		r12
	pop		r11
	pop		r10
	pop		r9
	pop		r8
	pop		r7
	pop		r6
	pop		r5
	pop		r4
	pop		r3
	pop		r2
	pop		r1
	pop		r0
	out		_SFR_IO_ADDR(SREG),r0
	pop		r0

	reti

terminate_task:
; --------------------------- ⨪ (  , ᫨ )
	cli
	clr		r1
	lds		r28,task_running
	lds		r29,task_running+1
	st		Y,r1
	std		Y+1,r1
; --------------------------- ⨪ த ... reti  ࠢ!
; 堫  ᫥饩 
	rjmp	task_loop


; 㭪 create_task (void(*task_pointer)(void), unsigned int* stack_bottom)
; 25:24 - 㪠⥫   室   ()
; 23:22 - 㪠⥫   ⥪  (ࠬ)

.global create_task
create_task:
	
	movw	r30,r22
	ldi		r22,lo8(terminate_task)
	ldi		r23,hi8(terminate_task)
	lsr		r23							;   ᤥ ஬!!!
	ror		r22							;   ᤥ ஬!!!
	st		-Z,r22
	st		-Z,r23
	st		-Z,r24
	st		-Z,r25
	st		-Z,r0
	in		r0,_SFR_IO_ADDR(SREG)
	st		-Z,r0
	st		-Z,r1
	sbiw	r30,31
	movw	r24,r30
;   25:24  㪠⥫  ⮢ ⥪

; --------------------------- ⨪ (  , ᫨ )
	cli
; 饬 ⮩ ᫮
	lds		r30,task_running
	lds		r31,task_running+1
task_loop1:
	adiw	r30,2
	cpi		r30,lo8(task_table+MAX_TASK_COUNT*2)
	brne	go_on1
	ldi		r30,lo8(task_table)
	ldi		r30,hi8(task_table)
 go_on1:
	ld		r22,Z		
	ldd		r23,Z+1
	or		r22,r23
	brne	task_loop1

; 諨. 堥 㤠  
	st		Z,r24
	std		Z+1,r25
	sei
; --------------------------- ⨪

	ret
	
